diff --git a/src/backend/executor/nodeBatchSort.c b/src/backend/executor/nodeBatchSort.c
new file mode 100644
index 0000000000..a157909374
--- /dev/null
+++ b/src/backend/executor/nodeBatchSort.c
@@ -0,0 +1,554 @@
+#include "postgres.h"
+
+#include "common/hashfn.h"
+#include "executor/executor.h"
+#include "executor/nodeBatchSort.h"
+#include "fmgr.h"
+#include "miscadmin.h"
+#include "pgstat.h"
+#include "port/atomics.h"
+#include "storage/barrier.h"
+#include "utils/builtins.h"
+#include "utils/tuplesort.h"
+#include "utils/typcache.h"
+
+typedef struct ParallelBatchSort
+{
+	Barrier				barrier;		/* data build barrier */
+	pg_atomic_uint32	attached;		/* how many worker attached */
+	pg_atomic_uint32	cur_batch;		/* current not final sort batch number */
+	Size				tuplesort_size;	/* MAXIMUM_ALIGNOF*n */
+}ParallelBatchSort;
+
+#define PARALLEL_BATCH_SORT_SIZE		MAXALIGN(sizeof(ParallelBatchSort))
+#define PARALLEL_BATCH_SORT_SHARED(p,n)	\
+	(Sharedsort*)(((char*)(p)) + PARALLEL_BATCH_SORT_SIZE + (p)->tuplesort_size * (n))
+
+#define BUILD_BATCH_DONE	1
+
+/*
+ * if we can scan next batch, then return true and open it,
+ * else return false
+ */
+static bool
+ExecNextParallelBatchSort(BatchSortState *state)
+{
+	ParallelBatchSort  *parallel = state->parallel;
+	BatchSort		   *plan = castNode(BatchSort, state->ps.plan);
+	SortCoordinateData	coord;
+	uint32				cur_batch;
+	Assert(parallel != NULL);
+
+	/* do we opened other batch? */
+	if (state->curBatch >= 0 &&
+		state->curBatch < plan->numBatches &&
+		state->batches[state->curBatch] != NULL)
+	{
+		/* close it */
+		tuplesort_end(state->batches[state->curBatch]);
+		state->batches[state->curBatch] = NULL;
+	}
+
+	/* get next batch number and set next number in shared memory */
+	cur_batch = pg_atomic_fetch_add_u32(&parallel->cur_batch, 1);
+	if (cur_batch >= plan->numBatches)
+	{
+		/* out of batch range, no more batch */
+		state->curBatch = plan->numBatches;
+		return false;
+	}
+
+	/* open tuplesort as leader */
+	Assert(state->batches[cur_batch] == NULL);
+	state->curBatch = cur_batch;
+	coord.isWorker = false;		/* we are leader */
+	coord.nParticipants = pg_atomic_read_u32(&parallel->attached);
+	coord.sharedsort = PARALLEL_BATCH_SORT_SHARED(parallel, cur_batch);
+	state->batches[cur_batch] = tuplesort_begin_heap(ExecGetResultType(outerPlanState(state)),
+													 plan->sort.numCols,
+													 plan->sort.sortColIdx,
+													 plan->sort.sortOperators,
+													 plan->sort.collations,
+													 plan->sort.nullsFirst,
+													 work_mem,
+													 &coord,
+													 false);
+	tuplesort_performsort(state->batches[cur_batch]);
+	return true;
+}
+
+/*
+ * return a empty TupleTableSlot
+ */
+static TupleTableSlot *
+ExecEmptyBatchSort(PlanState *pstate)
+{
+	return ExecClearTuple(pstate->ps_ResultTupleSlot);
+}
+
+/*
+ * scan tuple slot from tuplesort,
+ * all batch must be sort completed(called function ExecBatchSortPrepare)
+ */
+static TupleTableSlot *
+ExecBatchSort(PlanState *pstate)
+{
+	TupleTableSlot *slot = pstate->ps_ResultTupleSlot;
+	BatchSortState *state = castNode(BatchSortState, pstate);
+	Assert(state->sort_Done);
+
+re_get_:
+	/*
+	 * Get tuple from current tuplesort
+	 */
+	if (likely(tuplesort_gettupleslot(state->batches[state->curBatch],
+									  true,
+									  false,
+									  slot,
+									  NULL)))
+		return slot;
+
+	/*
+	 * Is all batches scanned?
+	 */
+	if (state->curBatch < castNode(BatchSort, pstate->plan)->numBatches-1)
+	{
+		/* Try next batch */
+		if (state->parallel)
+		{
+			if (ExecNextParallelBatchSort(state) == false)
+			{
+				/* No nore batches */
+				ExecSetExecProcNode(pstate, ExecEmptyBatchSort);
+				return ExecClearTuple(slot);
+			}
+			/*
+			 * OK, we can scan next batch,
+			 * function ExecNextParallelBatchSort changed curBatch
+			 */
+		}else
+		{
+			state->curBatch++;
+		}
+		goto re_get_;
+	}
+
+	/*
+	 * no more batches, return empty TupleTableSlot
+	 * tuplesort_gettupleslot cleaned slot
+	 */
+	Assert(TupIsNull(slot));
+	return slot;
+}
+
+/*
+ * Sorts tuples from the outer subree of the node using tuplesort
+ */
+static TupleTableSlot *
+ExecBatchSortPrepare(PlanState *pstate)
+{
+	BatchSort		   *node = castNode(BatchSort, pstate->plan);
+	BatchSortState	   *state = castNode(BatchSortState, pstate);
+	PlanState		   *outerNode = outerPlanState(pstate);
+	TupleTableSlot	   *slot;
+	ListCell		   *lc;
+	ParallelBatchSort  *parallel = state->parallel;
+	SortCoordinateData	coord;
+	FunctionCallInfo	fcinfo;
+	uint32				hash;
+	int					i;
+	AttrNumber			maxAttr;
+	Assert(state->sort_Done == false ||
+		   (parallel && BarrierPhase(&parallel->barrier) >= BUILD_BATCH_DONE));
+	Assert(list_length(state->groupFuns) == node->numGroupCols);
+
+	/* Is parallel mode */
+	if (parallel)
+	{
+		/* Attach to barrier and test current state */
+		if (BarrierAttach(&parallel->barrier) >= BUILD_BATCH_DONE)
+		{
+			/*
+			 * all tuples sorted by other workers
+			 * we don't need scan tuple from outer subtree
+			 * and can not change batches state(too late)
+			 */
+			goto build_already_done_;
+		}
+		/* let other workers known we are attached */
+		pg_atomic_add_fetch_u32(&parallel->attached, 1);
+	}
+
+	/* Make all tuplesort */
+	for (i=node->numBatches;i>0;)
+	{
+		--i;
+		if (parallel)
+		{
+			coord.isWorker = true;		/* We are not leader */
+			coord.nParticipants = -1;
+			coord.sharedsort = PARALLEL_BATCH_SORT_SHARED(parallel, i);
+		}
+		state->batches[i] = tuplesort_begin_heap(ExecGetResultType(outerNode),
+												 node->sort.numCols,
+												 node->sort.sortColIdx,
+												 node->sort.sortOperators,
+												 node->sort.collations,
+												 node->sort.nullsFirst,
+												 work_mem / node->numBatches,
+												 parallel ? &coord : NULL,
+												 false);
+	}
+
+	/*
+	 * Get max using attribute number,
+	 * we don't want call slot_getsomeattrs() more than once
+	 */
+	maxAttr = 0;
+	for (i=node->numGroupCols;i>0;)
+	{
+		if (maxAttr < node->grpColIdx[--i])
+			maxAttr = node->grpColIdx[i];
+	}
+	for (i=node->sort.numCols;i>0;)
+	{
+		if (maxAttr < node->sort.sortColIdx[--i])
+			maxAttr = node->sort.sortColIdx[i];
+	}
+	Assert(maxAttr > 0);
+
+	for (;;)
+	{
+		CHECK_FOR_INTERRUPTS();
+		slot = ExecProcNode(outerNode);
+		if (TupIsNull(slot))
+			break;
+
+		/* Get all we using datums from tuple */
+		slot_getsomeattrs(slot, maxAttr);
+
+		/* Get hash value */
+		hash = 0;
+		i = 0;
+		foreach(lc, state->groupFuns)
+		{
+			AttrNumber att = node->grpColIdx[i++]-1;
+			if (slot->tts_isnull[att] == false)
+			{
+				fcinfo = lfirst(lc);
+				fcinfo->args[0].value = slot->tts_values[att];
+				hash = hash_combine(hash, DatumGetUInt32(FunctionCallInvoke(fcinfo)));
+				Assert(fcinfo->isnull == false);
+			}
+		}
+
+		/* Put tuple to differed batch using hash value */
+		tuplesort_puttupleslot(state->batches[hash%node->numBatches], slot);
+	}
+
+	/* Finish all tuplesort put */
+	for (i=node->numBatches;i>0;)
+	{
+		--i;
+		tuplesort_performsort(state->batches[i]);
+		if (parallel)
+		{
+			/*
+			 * In parallel mode we need reopen tuplesort as leader
+			 * and almost impossible get all batches,
+			 * so we close it for free resource
+			 */
+			tuplesort_end(state->batches[i]);
+			state->batches[i] = NULL;
+		}
+	}
+
+	if (parallel)
+	{
+		/* Wait other workers finish sort */
+		BarrierArriveAndWait(&parallel->barrier, WAIT_EVENT_BATCH_SORT_BUILD);
+		Assert(BarrierPhase(&parallel->barrier) >= BUILD_BATCH_DONE);
+	}
+
+build_already_done_:
+	/* All tuplesort already done */
+	state->sort_Done = true;
+
+	/*
+	 * Change execute function.
+	 * Separating the preparation and scanning data functions helps to improve performance,
+	 * because we don't have to judge whether the data is ready every time
+	 */
+	if (parallel)
+	{
+		/* we don't need barrier any more */
+		BarrierDetach(&parallel->barrier);
+
+		if (ExecNextParallelBatchSort(state))
+			ExecSetExecProcNode(pstate, ExecBatchSort);	/* got a batch, we can scan it */
+		else
+			ExecSetExecProcNode(pstate, ExecEmptyBatchSort);	/* no more batch, so no more tuple */
+	}else
+	{
+		/* scan tuplesort from first batch */
+		state->curBatch = 0;
+		ExecSetExecProcNode(pstate, ExecBatchSort);
+	}
+
+	/* return first tuple or empty */
+	return (*pstate->ExecProcNodeReal)(pstate);
+}
+
+/*
+ * Create the run-time state information for the batch sort node
+ */
+BatchSortState *
+ExecInitBatchSort(BatchSort *node, EState *estate, int eflags)
+{
+	BatchSortState *state;
+	TypeCacheEntry *typentry;
+	TupleDesc		desc;
+	int				i;
+
+	state = makeNode(BatchSortState);
+	state->ps.plan = (Plan*) node;
+	state->ps.state = estate;
+	state->ps.ExecProcNode = ExecBatchSortPrepare;
+
+	state->sort_Done = false;
+	state->batches = palloc0(node->numBatches * sizeof(Tuplesortstate*));
+
+	outerPlanState(state) = ExecInitNode(outerPlan(node), estate, eflags);
+
+	/*
+	 * Initialize return slot and type. No need to initialize projection info
+	 * because this node doesn't do projections.
+	 */
+	ExecInitResultTupleSlotTL(&state->ps, &TTSOpsMinimalTuple);
+	state->ps.ps_ProjInfo = NULL;
+
+	/*
+	 * create hash function call info data
+	 */
+	Assert(node->numGroupCols > 0);
+	desc = ExecGetResultType(outerPlanState(state));
+	for (i=0;i<node->numGroupCols;++i)
+	{
+		FmgrInfo			   *flinfo;
+		FunctionCallInfo		fcinfo;
+		Form_pg_attribute		attr = TupleDescAttr(desc, node->grpColIdx[i]-1);
+		typentry = lookup_type_cache(attr->atttypid, TYPECACHE_HASH_PROC);
+		if (!OidIsValid(typentry->hash_proc))
+			ereport(ERROR,
+					(errcode(ERRCODE_UNDEFINED_FUNCTION),
+					 errmsg("could not identify an extended hash function for type %s",
+							format_type_be(attr->atttypid))));
+
+		/* Alloc memory for hash function call info data */
+		flinfo = palloc0(sizeof(*flinfo));
+		fcinfo = palloc0(SizeForFunctionCallInfo(1));	/* hash function only have one argument */
+		fmgr_info(typentry->hash_proc, flinfo);
+		InitFunctionCallInfoData(*fcinfo, flinfo, 1, attr->attcollation, NULL, NULL);
+		fcinfo->args[0].isnull = false;	/* first argument always not null */
+
+		/* Save call info data to run-time state */
+		state->groupFuns = lappend(state->groupFuns, fcinfo);
+	}
+
+	return state;
+}
+
+/*
+ * Free tuplesort resources
+ * and set "all tuplesort already done" as false
+ */
+static void
+CleanBatchSort(BatchSortState *node)
+{
+	int i;
+
+	ExecClearTuple(node->ps.ps_ResultTupleSlot);
+	if (node->sort_Done)
+	{
+		for (i=castNode(BatchSort, node->ps.plan)->numBatches;i>0;)
+		{
+			if (node->batches[--i] != NULL)
+			{
+				tuplesort_end(node->batches[i]);
+				node->batches[i] = NULL;
+			}
+		}
+		node->sort_Done = false;
+	}
+}
+
+void
+ExecEndBatchSort(BatchSortState *node)
+{
+	ExecClearTuple(node->ps.ps_ResultTupleSlot);
+	CleanBatchSort(node);
+	ExecEndNode(outerPlanState(node));
+}
+
+void
+ExecReScanBatchSort(BatchSortState *node)
+{
+	int					i;
+	Bitmapset		   *outerParams;
+	ParallelBatchSort  *parallel;
+	BatchSort		   *plan;
+
+	/* If we haven't sorted yet, just return. */
+	if (node->sort_Done == false)
+		return;
+
+	parallel = node->parallel;
+	outerParams = outerPlanState(node)->chgParam;
+	plan = castNode(BatchSort, node->ps.plan);
+
+	/* must drop pointer to sort result tuple */
+	ExecClearTuple(node->ps.ps_ResultTupleSlot);
+
+	if (bms_is_empty(outerParams) ||
+		/*
+		 * In parallel mod in parallel mode don't need rescan outer
+		 * when it only have gather param change,
+		 * because we cached all tuple from it and we can read in any worker
+		 */
+		(parallel != NULL &&
+		 plan->gather_param >= 0 &&
+		 bms_membership(outerParams) == BMS_SINGLETON &&
+		 bms_is_member(plan->gather_param, outerParams)))
+	{
+		if (parallel)
+		{
+			/* restart batches */
+			pg_atomic_write_u32(&parallel->cur_batch, 0);
+
+			/*
+			 * We want call ExecNextParallelBatchSort() function when
+			 * parent call ExecProcNode(), not now. Because it is possible that
+			 * other workers will finish processing other batches very quickly,
+			 * and we did occupy a batch and we have been in no hurry to deal with it.
+			 * So we don't want occupy a batch for now.
+			 */
+			ExecSetExecProcNode(&node->ps, ExecBatchSortPrepare);
+		}else
+		{
+			/* restart batches */
+			node->curBatch = 0;
+
+			/* rescan tuplesort */
+			i = plan->numBatches;
+			while (i>0)
+				tuplesort_rescan(node->batches[--i]);
+			ExecSetExecProcNode(&node->ps, ExecBatchSort);
+		}
+	}else
+	{
+		/* clean opend tuplesort */
+		CleanBatchSort(node);
+
+		if (parallel)
+		{
+			/* reset tuplesort */
+			i = plan->numBatches;
+			while (i>0)
+			{
+				--i;
+				tuplesort_reset_shared(PARALLEL_BATCH_SORT_SHARED(parallel, i));
+			}
+
+			/* reset shared memory */
+			BarrierInit(&parallel->barrier, 0);
+			pg_atomic_write_u32(&parallel->attached, 0);
+			pg_atomic_write_u32(&parallel->cur_batch, 0);
+		}
+		ExecSetExecProcNode(&node->ps, ExecBatchSortPrepare);
+		node->sort_Done = false;
+	}
+}
+
+void
+ExecShutdownBatchSort(BatchSortState *node)
+{
+	CleanBatchSort(node);
+}
+
+/* ----------------------------------------------------------------
+ *						Parallel Query Support
+ * ----------------------------------------------------------------
+ */
+
+/* ----------------------------------------------------------------
+ *		ExecBatchSortEstimate
+ *
+ *		Estimate space required to propagate sort statistics.
+ * ----------------------------------------------------------------
+ */
+void
+ExecBatchSortEstimate(BatchSortState *node, ParallelContext *pcxt)
+{
+	Size size = mul_size(MAXALIGN(tuplesort_estimate_shared(pcxt->nworkers+1)),
+						 castNode(BatchSort, node->ps.plan)->numBatches);
+	size = add_size(size, PARALLEL_BATCH_SORT_SIZE);
+
+	shm_toc_estimate_chunk(&pcxt->estimator, size);
+	shm_toc_estimate_keys(&pcxt->estimator, 1);
+}
+
+/* Initialize shared memory for batch sort */
+static void
+InitializeBatchSortParallel(ParallelBatchSort *parallel,
+							int num_batches,
+							int num_workers,
+							dsm_segment *seg)
+{
+	int i;
+	BarrierInit(&parallel->barrier, 0);
+	pg_atomic_init_u32(&parallel->attached, 0);
+	pg_atomic_init_u32(&parallel->cur_batch, 0);
+	for (i=0;i<num_batches;++i)
+	{
+		tuplesort_initialize_shared(PARALLEL_BATCH_SORT_SHARED(parallel, i),
+									num_workers,
+									seg);
+	}
+}
+
+void
+ExecBatchSortInitializeDSM(BatchSortState *node, ParallelContext *pcxt)
+{
+	ParallelBatchSort  *parallel;
+	BatchSort		   *plan = castNode(BatchSort, node->ps.plan);
+	Size				tuplesort_size = MAXALIGN(tuplesort_estimate_shared(pcxt->nworkers+1));
+	Size				size = mul_size(tuplesort_size, plan->numBatches);
+	size = add_size(PARALLEL_BATCH_SORT_SIZE, size);
+
+	node->parallel = parallel = shm_toc_allocate(pcxt->toc, size);
+	parallel->tuplesort_size = tuplesort_size;
+	InitializeBatchSortParallel(parallel, plan->numBatches, pcxt->nworkers+1, pcxt->seg);
+	shm_toc_insert(pcxt->toc, plan->sort.plan.plan_node_id, parallel);
+}
+
+void
+ExecBatchSortReInitializeDSM(BatchSortState *node, ParallelContext *pcxt)
+{
+	pg_atomic_write_u32(&node->parallel->cur_batch, 0);
+}
+
+void
+ExecBatchSortInitializeWorker(BatchSortState *node, ParallelWorkerContext *pwcxt)
+{
+	uint32				i;
+	BatchSort		   *plan = castNode(BatchSort, node->ps.plan);
+	ParallelBatchSort  *parallel = shm_toc_lookup(pwcxt->toc,
+												  plan->sort.plan.plan_node_id,
+												  false);
+	node->parallel = parallel;
+	for (i=0;i<plan->numBatches;++i)
+	{
+		tuplesort_attach_shared(PARALLEL_BATCH_SORT_SHARED(parallel, i),
+								pwcxt->seg);
+	}
+}
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index ba3ccc712c..7ee5d673f1 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -959,6 +959,23 @@ _copySort(const Sort *from)
 	return newnode;
 }
 
+/*
+ * _copyBatchSort
+ */
+static BatchSort *
+_copyBatchSort(const BatchSort *from)
+{
+	BatchSort	   *newnode = makeNode(BatchSort);
+
+	CopySortFields(&from->sort, &newnode->sort);
+
+	COPY_SCALAR_FIELD(numGroupCols);
+	COPY_SCALAR_FIELD(numBatches);
+	COPY_SCALAR_FIELD(gather_param);
+	COPY_POINTER_FIELD(grpColIdx, from->numGroupCols * sizeof(AttrNumber));
+
+	return newnode;
+}
 
 /*
  * _copyIncrementalSort
@@ -1024,6 +1041,8 @@ _copyAgg(const Agg *from)
 	COPY_BITMAPSET_FIELD(aggParams);
 	COPY_NODE_FIELD(groupingSets);
 	COPY_NODE_FIELD(chain);
+	COPY_SCALAR_FIELD(numBatches);
+	COPY_SCALAR_FIELD(gatherParam);
 
 	return newnode;
 }
@@ -4948,6 +4967,9 @@ copyObjectImpl(const void *from)
 		case T_Sort:
 			retval = _copySort(from);
 			break;
+		case T_BatchSort:
+			retval = _copyBatchSort(from);
+			break;
 		case T_IncrementalSort:
 			retval = _copyIncrementalSort(from);
 			break;
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 8392be6d44..61187685a6 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -785,6 +785,8 @@ _outAgg(StringInfo str, const Agg *node)
 	WRITE_BITMAPSET_FIELD(aggParams);
 	WRITE_NODE_FIELD(groupingSets);
 	WRITE_NODE_FIELD(chain);
+	WRITE_INT_FIELD(numBatches);
+	WRITE_INT_FIELD(gatherParam);
 }
 
 static void
@@ -854,6 +856,19 @@ _outSort(StringInfo str, const Sort *node)
 	_outSortInfo(str, node);
 }
 
+static void
+_outBatchSort(StringInfo str, const BatchSort *node)
+{
+	WRITE_NODE_TYPE("BATCHSORT");
+
+	_outSortInfo(str, &node->sort);
+
+	WRITE_INT_FIELD(numGroupCols);
+	WRITE_INT_FIELD(numBatches);
+	WRITE_INT_FIELD(gather_param);
+	WRITE_ATTRNUMBER_ARRAY(grpColIdx, node->numGroupCols);
+}
+
 static void
 _outIncrementalSort(StringInfo str, const IncrementalSort *node)
 {
@@ -3836,6 +3851,9 @@ outNode(StringInfo str, const void *obj)
 			case T_Sort:
 				_outSort(str, obj);
 				break;
+			case T_BatchSort:
+				_outBatchSort(str, obj);
+				break;
 			case T_IncrementalSort:
 				_outIncrementalSort(str, obj);
 				break;
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index d2c8d58070..e0d225aa85 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -2182,6 +2182,21 @@ _readSort(void)
 	READ_DONE();
 }
 
+static BatchSort *
+_readBatchSort(void)
+{
+	READ_LOCALS(BatchSort);
+
+	ReadCommonSort(&local_node->sort);
+
+	READ_INT_FIELD(numGroupCols);
+	READ_INT_FIELD(numBatches);
+	READ_INT_FIELD(gather_param);
+	READ_ATTRNUMBER_ARRAY(grpColIdx, local_node->numGroupCols);
+
+	READ_DONE();
+}
+
 /*
  * _readIncrementalSort
  */
@@ -2236,6 +2251,8 @@ _readAgg(void)
 	READ_BITMAPSET_FIELD(aggParams);
 	READ_NODE_FIELD(groupingSets);
 	READ_NODE_FIELD(chain);
+	READ_INT_FIELD(numBatches);
+	READ_INT_FIELD(gatherParam);
 
 	READ_DONE();
 }
@@ -2835,6 +2852,8 @@ parseNodeString(void)
 		return_value = _readMaterial();
 	else if (MATCH("SORT", 4))
 		return_value = _readSort();
+	else if (MATCH("BATCHSORT", 9))
+		return_value = _readBatchSort();
 	else if (MATCH("INCREMENTALSORT", 15))
 		return_value = _readIncrementalSort();
 	else if (MATCH("GROUP", 5))
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 380336518f..c0a75e31c1 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -147,6 +147,8 @@ bool		enable_partitionwise_aggregate = false;
 bool		enable_parallel_append = true;
 bool		enable_parallel_hash = true;
 bool		enable_partition_pruning = true;
+int			max_sort_batches = 0;
+int			max_hashagg_batches = 0;
 
 typedef struct
 {
@@ -1958,6 +1960,84 @@ cost_sort(Path *path, PlannerInfo *root,
 	path->total_cost = startup_cost + run_cost;
 }
 
+void cost_batchsort(Path *path, PlannerInfo *root,
+					List *batchkeys, Cost input_cost,
+					double tuples, int width,
+					Cost comparison_cost, int sort_mem,
+					uint32 numGroupCols, uint32 numBatches)
+{
+	Cost		startup_cost = input_cost;
+	Cost		run_cost = 0;
+	double		input_bytes = relation_byte_size(tuples, width);
+	double		batch_bytes = input_bytes / numBatches;
+	double		batch_tuples = tuples / numBatches;
+	long		sort_mem_bytes = sort_mem * 1024L;
+
+	if (sort_mem_bytes < (64*1024))
+		sort_mem_bytes = (64*1024);
+
+	/* hash cost */
+	startup_cost += cpu_operator_cost * numGroupCols * tuples;
+
+	path->rows = tuples;
+
+	/*
+	 * We want to be sure the cost of a sort is never estimated as zero, even
+	 * if passed-in tuple count is zero.  Besides, mustn't do log(0)...
+	 */
+	if (tuples < 2.0)
+		tuples = 2.0;
+
+	if (batch_bytes > sort_mem_bytes)
+	{
+		/*
+		 * We'll have to use a disk-based sort of all the tuples
+		 */
+		double		npages = ceil(batch_bytes / BLCKSZ);
+		double		nruns = batch_bytes / sort_mem_bytes;
+		double		mergeorder = tuplesort_merge_order(sort_mem_bytes);
+		double		log_runs;
+		double		npageaccesses;
+
+		/*
+		 * CPU costs
+		 *
+		 * Assume about N log2 N comparisons
+		 */
+		startup_cost += comparison_cost * batch_tuples * LOG2(batch_tuples) * numBatches;
+
+		/* Disk costs */
+
+		/* Compute logM(r) as log(r) / log(M) */
+		if (nruns > mergeorder)
+			log_runs = ceil(log(nruns) / log(mergeorder));
+		else
+			log_runs = 1.0;
+		npageaccesses = 2.0 * npages * log_runs;
+		/* Assume 3/4ths of accesses are sequential, 1/4th are not */
+		startup_cost += npageaccesses * numBatches *
+			(seq_page_cost * 0.75 + random_page_cost * 0.25);
+
+	}else
+	{
+		/* We'll use plain quicksort on all the input tuples */
+		startup_cost += comparison_cost * tuples * LOG2(tuples);
+	}
+
+	/*
+	 * Also charge a small amount (arbitrarily set equal to operator cost) per
+	 * extracted tuple.  We don't charge cpu_tuple_cost because a Sort node
+	 * doesn't do qual-checking or projection, so it has less overhead than
+	 * most plan nodes.  Note it's correct to use tuples not output_tuples
+	 * here --- the upper LIMIT will pro-rate the run cost so we'd be double
+	 * counting the LIMIT otherwise.
+	 */
+	run_cost += cpu_operator_cost * tuples;
+
+	path->startup_cost = startup_cost;
+	path->total_cost = startup_cost + run_cost;
+}
+
 /*
  * append_nonpartial_cost
  *	  Estimate the cost of the non-partial paths in a Parallel Append.
@@ -2332,7 +2412,7 @@ cost_agg(Path *path, PlannerInfo *root,
 	/* Use all-zero per-aggregate costs if NULL is passed */
 	if (aggcosts == NULL)
 	{
-		Assert(aggstrategy == AGG_HASHED);
+		Assert(aggstrategy == AGG_HASHED || aggstrategy == AGG_BATCH_HASH);
 		MemSet(&dummy_aggcosts, 0, sizeof(AggClauseCosts));
 		aggcosts = &dummy_aggcosts;
 	}
@@ -2391,10 +2471,13 @@ cost_agg(Path *path, PlannerInfo *root,
 	}
 	else
 	{
-		/* must be AGG_HASHED */
+		/* must be AGG_HASHED or AGG_BATCH_HASH */
+		Assert(aggstrategy == AGG_HASHED || max_hashagg_batches > 0);
 		startup_cost = input_total_cost;
-		if (!enable_hashagg)
+		if (aggstrategy == AGG_HASHED && !enable_hashagg)
+		{
 			startup_cost += disable_cost;
+		}
 		startup_cost += aggcosts->transCost.startup;
 		startup_cost += aggcosts->transCost.per_tuple * input_tuples;
 		/* cost of computing hash value */
@@ -2406,6 +2489,15 @@ cost_agg(Path *path, PlannerInfo *root,
 		/* cost of retrieving from hash table */
 		total_cost += cpu_tuple_cost * numGroups;
 		output_tuples = numGroups;
+
+		if (aggstrategy == AGG_BATCH_HASH)
+		{
+			double	nbytes = relation_byte_size(input_tuples, input_width);
+			double	npages = ceil(nbytes / BLCKSZ);
+			double	material_cost = (seq_page_cost * npages);
+			startup_cost += material_cost;
+			total_cost += material_cost;
+		}
 	}
 
 	/*
@@ -2421,7 +2513,9 @@ cost_agg(Path *path, PlannerInfo *root,
 	 * Accrue writes (spilled tuples) to startup_cost and to total_cost;
 	 * accrue reads only to total_cost.
 	 */
-	if (aggstrategy == AGG_HASHED || aggstrategy == AGG_MIXED)
+	if (aggstrategy == AGG_HASHED ||
+		aggstrategy == AGG_BATCH_HASH ||
+		aggstrategy == AGG_MIXED)
 	{
 		double		pages;
 		double		pages_written = 0.0;
@@ -2434,6 +2528,14 @@ cost_agg(Path *path, PlannerInfo *root,
 		int			num_partitions;
 		int			depth;
 
+		if (aggstrategy == AGG_BATCH_HASH &&
+			numGroups > max_hashagg_batches)
+		{
+			numGroups /= max_hashagg_batches;
+			if (numGroups < 1.0)
+				numGroups = 1.0;
+		}
+
 		/*
 		 * Estimate number of batches based on the computed limits. If less
 		 * than or equal to one, all groups are expected to fit in memory;
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 25d4750ca6..baa645529c 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -30,6 +30,7 @@
 #include "optimizer/cost.h"
 #include "optimizer/optimizer.h"
 #include "optimizer/paramassign.h"
+#include "optimizer/pathnode.h"
 #include "optimizer/paths.h"
 #include "optimizer/placeholder.h"
 #include "optimizer/plancat.h"
@@ -98,6 +99,7 @@ static Plan *create_projection_plan(PlannerInfo *root,
 									int flags);
 static Plan *inject_projection_plan(Plan *subplan, List *tlist, bool parallel_safe);
 static Sort *create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags);
+static BatchSort *create_batchsort_plan(PlannerInfo *root, BatchSortPath *best_path, int flags);
 static IncrementalSort *create_incrementalsort_plan(PlannerInfo *root,
 													IncrementalSortPath *best_path, int flags);
 static Group *create_group_plan(PlannerInfo *root, GroupPath *best_path);
@@ -468,6 +470,11 @@ create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 											 (SortPath *) best_path,
 											 flags);
 			break;
+		case T_BatchSort:
+			plan = (Plan *) create_batchsort_plan(root,
+												  (BatchSortPath*) best_path,
+												  flags);
+			break;
 		case T_IncrementalSort:
 			plan = (Plan *) create_incrementalsort_plan(root,
 														(IncrementalSortPath *) best_path,
@@ -2009,6 +2016,40 @@ create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags)
 	return plan;
 }
 
+static BatchSort *create_batchsort_plan(PlannerInfo *root, BatchSortPath *best_path, int flags)
+{
+	BatchSort	   *plan;
+	Plan		   *subplan;
+
+	subplan = create_plan_recurse(root, best_path->subpath,
+								  flags | CP_SMALL_TLIST);
+
+	plan = makeNode(BatchSort);
+	subplan = prepare_sort_from_pathkeys(subplan,
+										 best_path->batchkeys,
+										 IS_OTHER_REL(best_path->subpath->parent) ?
+											 best_path->path.parent->relids : NULL,
+										 NULL,
+										 false,
+										 &plan->sort.numCols,
+										 &plan->sort.sortColIdx,
+										 &plan->sort.sortOperators,
+										 &plan->sort.collations,
+										 &plan->sort.nullsFirst);
+	plan->sort.plan.targetlist = subplan->targetlist;
+	plan->sort.plan.qual = NIL;
+	outerPlan(plan) = subplan;
+	innerPlan(plan) = NULL;
+	plan->numBatches = best_path->numBatches;
+	plan->numGroupCols = list_length(best_path->batchgroup);
+	plan->gather_param = -1;
+	plan->grpColIdx = extract_grouping_cols(best_path->batchgroup,
+											subplan->targetlist);
+
+	copy_generic_path_info(&plan->sort.plan, &best_path->path);
+	return plan;
+}
+
 /*
  * create_incrementalsort_plan
  *
@@ -2085,6 +2126,12 @@ create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flag
 {
 	Unique	   *plan;
 	Plan	   *subplan;
+	List	   *pathkeys;
+
+	if (IsA(best_path->subpath, BatchSortPath))
+		pathkeys = ((BatchSortPath*)best_path->subpath)->batchkeys;
+	else
+		pathkeys = best_path->path.pathkeys;
 
 	/*
 	 * Unique doesn't project, so tlist requirements pass through; moreover we
@@ -2094,7 +2141,7 @@ create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path, int flag
 								  flags | CP_LABEL_TLIST);
 
 	plan = make_unique_from_pathkeys(subplan,
-									 best_path->path.pathkeys,
+									 pathkeys,
 									 best_path->numkeys);
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
@@ -2282,7 +2329,9 @@ create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path)
 			if (!rollup->is_hashed)
 				is_first_sort = false;
 
-			if (rollup->is_hashed)
+			if (best_path->aggstrategy == AGG_BATCH_HASH)
+				strat = AGG_BATCH_HASH;
+			else if (rollup->is_hashed)
 				strat = AGG_HASHED;
 			else if (list_length(linitial(rollup->gsets)) == 0)
 				strat = AGG_PLAIN;
@@ -6373,12 +6422,20 @@ make_agg(List *tlist, List *qual,
 	node->aggParams = NULL;		/* SS_finalize_plan() will fill this */
 	node->groupingSets = groupingSets;
 	node->chain = chain;
+	node->gatherParam = -1;
 
 	plan->qual = qual;
 	plan->targetlist = tlist;
 	plan->lefttree = lefttree;
 	plan->righttree = NULL;
 
+	if (aggstrategy == AGG_BATCH_HASH)
+	{
+		node->numBatches = (int32)numGroups;
+		if (node->numBatches > max_hashagg_batches)
+			node->numBatches = max_hashagg_batches;
+	}
+
 	return node;
 }
 
